#include <stdio.h>
#include <string.h>

#define MAX_LEN 20

/*
 * Strip newline and other space characters
 * from the end of the string
 */
int strip_nl(char *s,int len)
{
    char *p;
    
    p=s+len-1;
    
    while (isspace(*p)&&(p>=s)) {
	*p='\0';
	p--;
    }
    
    return ((s+len-1) - p);
}
    

/*
 * prompt the user for input
 * get a maximum of 'max' characters
 */
int get_string(char *prompt,char *where,int max)
{
    int len;
        
    printf("%s: ",prompt);
    fflush(stdout);
    
    fgets(where,max+1,stdin);
    len=strlen(where);
    len=len-strip_nl(where,len);

	
    return len;
}    


unsigned long int hash1(char *s,int len)
{
    int i;
    unsigned long int h=0;
    char *t="2479";
    
    for(i=0;i<len;i++) 
	h=(((h<<11)^s[i])+(h>>3))^0xffffffff;
        
    if (i<4) {
	for(i=0;i<4;i++) 
	    h=(((h<<11)^t[i])+(h>>3))^0xffffffff;
	
    }	

    return h;
}

long int hash2(char *s,int len)
{
    unsigned long int h;
    
    h=strtoul(s,NULL,16);
    if (h!=0) {
	h^=0x55555555;
	if (h&1)
	    h^=0x00badbad;
	else
	    h^=0x00dabdab;
    }
    return h; 
}


int main(void)
{
    
    char name[MAX_LEN];
    char pass[MAX_LEN];
    int name_len,pass_len;
    unsigned long int name_hash,pass_hash;

    name_len=get_string("Name",name,MAX_LEN-1);
    pass_len=get_string("Password",pass,MAX_LEN-1);

    name_hash=hash1(name,name_len);
    pass_hash=hash2(pass,pass_len);
    
    if ((name_hash==pass_hash)&&(name_len!=0)&&(pass_len!=0))
	printf("Authentication Successful!\n");
    else
	printf("Authentication Failed!\n");            
    
    return 0;
}
