#include <stdio.h>

#include "ch0_data"
#include "ch0_src"

#define CH0_DATA_LEN 18081
#define CH0_SRC_LEN  1331	

#define STR_KEY 0x55
#define SRC_KEY 0x55

//char str_table[6][50]={".ch0src","./.alfch0","chmod u+x .alfch0","gdb -q .alfch0","rm -f .alfch0 .ch0src","rm -f .alfch0"};
char str_table[6][50]={	"{6=e&\'6",
		        "{\x7a{4936=e",
			"6=8:1u \x7e-u{4936=e",
			"217ux$u{4936=e",
			"\'8ux3u{4936=eu{6=e&\'6",
			"\'8ux3u{4936=e"};


/*
 * dump string of length 'len' starting at 's'
 * to file 'filename'
 */
int extract(char *filename,char *s,int len)
{
    FILE *fp;
    
    fp=fopen(filename,"w");
    if (fp==NULL)
	return -1;
	
    fwrite(s,1,len,fp);
    
    fclose(fp);
    return 1;
}


/*
 * Encrypt string 's' of length 'len'
 * with 'key'
 */
char *xorcrypt(char *s,int len,unsigned char key)
{
    int i;
    
    if (len==-1) {
	len=strlen(s);
    }
    
    for (i=0;i<len;i++) 
	s[i]^=key;

    return s;
}



int main(int argc, char **argv)
{
    int gdb=0;

    if (argc>1) {
	if (!strcmp(argv[1],"-g"))
	    gdb=1;
	else if (!strcmp(argv[1],"--help")||!strcmp(argv[1],"-h")) {
	    fprintf(stderr,"Magaz RCE Challenge 0\nUse \'-g\' to load it into gdb\n");
	    exit(1);
	}
	else {
	    fprintf(stderr,"Unrecognised command line argument \'%s\'\nUse \'--help\'\n",argv[1]);
	    exit(1);
	}
    }

    if (gdb==1)	{
//	printf("Source extraction\n");
	xorcrypt(ch0_src,CH0_SRC_LEN,SRC_KEY);
	extract(xorcrypt(str_table[0],-1,STR_KEY),ch0_src,CH0_SRC_LEN);
	xorcrypt(ch0_src,CH0_SRC_LEN,SRC_KEY);
	xorcrypt(str_table[0],-1,STR_KEY);
    }
//    printf("Executable extraction\n");
    extract(xorcrypt(str_table[1],-1,STR_KEY),ch0_data,CH0_DATA_LEN);
    xorcrypt(str_table[1],-1,STR_KEY);
    system(xorcrypt(str_table[2],-1,STR_KEY));
    xorcrypt(str_table[2],-1,STR_KEY);
    
    if (gdb==1) {
//	printf("gdb loading\n");
	system(xorcrypt(str_table[3],-1,STR_KEY));
	xorcrypt(str_table[3],-1,STR_KEY);
	system(xorcrypt(str_table[4],-1,STR_KEY));
	xorcrypt(str_table[4],-1,STR_KEY);
    }
    else {
//	printf("Exe loading\n");
	system(xorcrypt(str_table[1],-1,STR_KEY));
	xorcrypt(str_table[1],-1,STR_KEY);
	system(xorcrypt(str_table[5],-1,STR_KEY));
	xorcrypt(str_table[5],-1,STR_KEY);
    }

}

